/*
 * StringTableModel.java
 *
 * Created on 9 de marzo de 2007, 19:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package datareader;

import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author bruegel
 */
public class StringTableModel extends AbstractTableModel {
    

    ArrayList<ArrayList<String>> stm;
    
    public StringTableModel() {
        stm = new ArrayList<ArrayList<String>>();
        ArrayList<String> row = new ArrayList<String>();
        stm.add(row);
    }
    public StringTableModel(String[][] data) {
        stm = new ArrayList<ArrayList<String>>();
        int numRows = data.length;
        int numCols = data[0].length;
        ArrayList<String> row = null;
        for(int i=0; i< numRows;i++) {
            row = new ArrayList<String>();
            for(int j=0;j<numCols;j++)
                row.add(data[i][j]);
            stm.add(row);
        }
    }
    
    public int getRowCount() {
        return stm.size();
    }
    
    public int getColumnCount() {
        if (stm.isEmpty())
            return 0;
        else
            return stm.get(0).size();
    }
    
    public Object getValueAt(int i, int i0) {
        return stm.get(i).get(i0);
    }
    
    public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
    
    public void setValueAt(Object element, int i, int j){
        String datum = (String)element;
        /*
         * If we process numbers, it would be a good idea
         * to check for number validity here.
         */
        if (j>stm.get(i).size())
            stm.get(i).ensureCapacity(j+1);
        stm.get(i).set(j,(String)element);
        fireTableCellUpdated(i,j);
        
    }
    // To do: addRow, addColumn, insertRow, insertColumn
    public void populateWithTable(String[][] data){
        this.clearModel();
        stm = new ArrayList<ArrayList<String>>();
        int numRows = data.length;
        int numCols = data[0].length;
        ArrayList<String> row = null;
        for(int i=0; i< numRows;i++) {
            row = new ArrayList<String>();
            for(int j=0;j<numCols;j++)
                row.add(data[i][j]);
            stm.add(row);
        }
    }
    
    public String[][] getDataAsStringTable(){
        int rowCount = this.getRowCount();
        int columnCount = this.getColumnCount();
        String[][] data = new String[rowCount][columnCount];
        for(int i=0;i<rowCount;i++)
            for(int j=0;j<columnCount;j++)
                data[i][j]=stm.get(i).get(j);
        return data;
    }
    
    public void clearModel(){
        int rowCount = this.getRowCount();
        for(int i=0;i<rowCount;i++)
            stm.get(i).clear();
        stm.clear();
    }
    public boolean isCellEditable(int row, int col) {
        return true;
    }
}
