/*
 * MainDialog.java
 *
 * Created on 6 de marzo de 2007, 19:35
 */

package samplertoo;

import java.awt.Toolkit;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.NumberFormat;
import java.util.Locale;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 * This class produces sets of data to be used for testing. It can produce just
 * about any number of rows and columns of random numbers within a given range.
 * Separators are currently tabs; this can be changed easily. One possible
 * enhancement is to produce a columnar format (in fact this is columnar since
 * all numbers are equal in length).
 * @author bruegel
 */
public class MainDialog extends javax.swing.JFrame {
    
    /**
     * Sets up the text fields for number of columns, number of rows, minimum value,
     * maximum value and destination file. Tabbing sequence is set. Hit space when a
     * button is selected.
     */
    public MainDialog() {
        initComponents();
        outfile = null;
        this.setTitle("Sample generator");
        
    }
    
    
    /**
     * Getter for the exit button.
     * @return  The descriptor for the exit button.
     */
    public javax.swing.JButton getExitButton() {
        return exitButton;
    }
    
    /**
     *  Setter for the exit button.
     */
    public void setExitButton(javax.swing.JButton exitButton) {
        this.exitButton = exitButton;
    }
    
    public javax.swing.JButton getChofButton() {
        return chofButton;
    }
    
    public void setChofButton(javax.swing.JButton chofButton) {
        this.chofButton = chofButton;
    }
    
    public javax.swing.JButton getOkButton() {
        return okButton;
    }
    
    public void setOkButton(javax.swing.JButton okButton) {
        this.okButton = okButton;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        exitButton = new javax.swing.JButton();
        chofButton = new javax.swing.JButton();
        noc_jt = new javax.swing.JTextField();
        nor_jt = new javax.swing.JTextField();
        minval_jt = new javax.swing.JTextField();
        maxval_jt = new javax.swing.JTextField();
        chof_jt = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Sampler");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setLocationByPlatform(true);
        setResizable(false);
        jLabel1.setText("Number of columns");

        jLabel2.setText("Number of rows");

        jLabel3.setText("Minimum value");

        jLabel4.setText("Maximum value");

        jLabel5.setText("Chosen output file");

        okButton.setText("Ok");
        okButton.setDefaultCapable(false);
        okButton.setNextFocusableComponent(exitButton);
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        exitButton.setText("Exit");
        exitButton.setDefaultCapable(false);
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        chofButton.setText("Change output file");
        chofButton.setNextFocusableComponent(okButton);
        chofButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chofButtonActionPerformed(evt);
            }
        });

        noc_jt.setText("1");
        noc_jt.setFocusCycleRoot(true);
        noc_jt.setNextFocusableComponent(nor_jt);

        nor_jt.setText("10");
        nor_jt.setNextFocusableComponent(minval_jt);

        minval_jt.setText("0.0");
        minval_jt.setNextFocusableComponent(maxval_jt);

        maxval_jt.setText("1.0");
        maxval_jt.setNextFocusableComponent(chofButton);

        chof_jt.setBackground(new java.awt.Color(204, 204, 204));
        chof_jt.setEditable(false);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(exitButton)
                    .add(jLabel5)
                    .add(jLabel3)
                    .add(jLabel1))
                .add(9, 9, 9)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(minval_jt)
                            .add(noc_jt, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 67, Short.MAX_VALUE))
                        .add(25, 25, 25)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jLabel2)
                            .add(jLabel4))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(maxval_jt)
                            .add(nor_jt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 111, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(layout.createSequentialGroup()
                        .add(chofButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(okButton))
                    .add(chof_jt))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(new java.awt.Component[] {chofButton, exitButton, okButton}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(nor_jt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel1)
                    .add(noc_jt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel2))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(jLabel4)
                    .add(maxval_jt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(minval_jt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel5)
                    .add(chof_jt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(exitButton)
                    .add(chofButton)
                    .add(okButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    /**
     * This method fires the change of output file
     */
    private void chofButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chofButtonActionPerformed
        JFileChooser jfc = new JFileChooser(System.getProperty("user.dir"));
        int result = jfc.showSaveDialog(this);
        String temp = "null";
        if (JFileChooser.APPROVE_OPTION==result){
            try {
                temp = jfc.getSelectedFile().getCanonicalPath();
                chof_jt.setText(temp);
                
                getRootPane().setDefaultButton(okButton);
                okButton.requestFocus();
            } catch (IOException ex) {
                Toolkit.getDefaultToolkit().beep();
                chof_jt.setText("/No valid output file/Pls select one");
                
                getRootPane().setDefaultButton(chofButton);
                chofButton.requestFocus();
            }
        }
    }//GEN-LAST:event_chofButtonActionPerformed
    
    /**
     * This method actually creates de output file.
     */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // First pick up data
        int numberOfRows = Integer.parseInt(nor_jt.getText());
        int numberOfColumns = Integer.parseInt(noc_jt.getText());
        float minval = Float.parseFloat(minval_jt.getText());
        float maxval = Float.parseFloat(maxval_jt.getText());
        String lineSep = System.getProperty("line.separator");
        double temp = 0.0;
        // Then write the samples
        NumberFormat nf = NumberFormat.getInstance(Locale.US);
        nf.setMinimumFractionDigits(6);
        try{
            outfile = new File(chof_jt.getText());
            PrintWriter pw = new PrintWriter(outfile);
            for(int row=0;row<numberOfRows;row++) {
                for(int col=0;col<numberOfColumns;col++){
                    temp = minval+Math.random()*(maxval-minval);
                    pw.print(nf.format(temp));
                    pw.printf("%s",col == numberOfColumns-1?lineSep:"\t");
                }
            }
            pw.close();
            Toolkit.getDefaultToolkit().beep();
            JOptionPane.showMessageDialog(this, outfile.getName()+" created correctly.");

        } catch(Exception e){
            Toolkit.getDefaultToolkit().beep();
            chof_jt.setText("/No valid output file/Please select one");
        }
        getRootPane().setDefaultButton(exitButton);
        exitButton.requestFocus(true);
        exitButton.setFocusPainted(true);
        okButton.setFocusPainted(false);
        
    }//GEN-LAST:event_okButtonActionPerformed
    
    /**
     * Exits the program
     */
    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
// TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_exitButtonActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton chofButton;
    /**
     * The path of the output file. Empty on start, must be set.
     */
    private javax.swing.JTextField chof_jt;
    private javax.swing.JButton exitButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    /**
     * The maximum value for the random number generator.
     */
    private javax.swing.JTextField maxval_jt;
    /**
     * The minimum value for the random number generator.
     */
    private javax.swing.JTextField minval_jt;
    /**
     * The number of columns.
     */
    private javax.swing.JTextField noc_jt;
    /**
     * The number of rows
     */
    private javax.swing.JTextField nor_jt;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
    /**
     * The destination file.
     */
    private File outfile;
    
    public File getOutfile() {
        return outfile;
    }
    
    public void setOutfile(File outfile) {
        this.outfile = outfile;
    }
}
