import java.awt.Color;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.Scanner;
import javax.swing.JApplet;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import com.coti.graphics.PiePlot;

/**
 *
 * @author bruegel
 */
public class PieChartApplet extends JApplet implements Runnable {
    
    /*
        List of methods
     */
    public void init(){
        initComponents();
    }
    
    public void initComponents(){
        jta = new JTextArea();
        jta.setLineWrap(true);
        jta.setWrapStyleWord(true);
        jsc = new JScrollPane(jta);
        jt = new JTabbedPane();
        jt.add(jsc,"Data");
        add(jt);
        loadFinished=false;
        dataLoaded=false;
        data = null;
        doLoad();
        try {
            while(!loadFinished) Thread.sleep(100);
        } catch(Exception e) {
        }
        if (dataLoaded) {
            PiePlot p = new PiePlot(data,null,legend);
            jt.add(p,"Pie chart");
        }
    }
    
    public void run() {
        rawdata.clear();
        jta.setText("Loading data...");
        try {
            URL u = new URL(getCodeBase(),"data.txt");
            URLConnection uc = u.openConnection();
            Scanner sc = new Scanner(uc.getInputStream());
            while(sc.hasNextLine())
                rawdata.add(sc.nextLine());
            sc.close();
        } catch (MalformedURLException ex) {
            ex.printStackTrace();
            jta.setText("");
            putText("\nError:\n"+ex);
            loadFinished=true;
            dataLoaded=false;
            return;
        }catch (java.io.IOException ex) {
            jta.setText("");
            putText("Error:\n"+ex);
            ex.printStackTrace();
            loadFinished=true;
            dataLoaded=false;
            return;
        } catch(Exception ex){
            putText("Error:\n"+ex);
            ex.printStackTrace();
            loadFinished=true;
            dataLoaded=false;
            return;
        }
        
        int numberOfRows = rawdata.size();
        data = new float[numberOfRows];
        legend = new String[numberOfRows];
        String[] fields = null;
        try {
            for(int i=0;i<numberOfRows;i++){
                fields = rawdata.get(i).split("\t");
                data[i] = Float.parseFloat(fields[0]);
                legend[i] = fields[1];
            }
            putText("done.\n\nData are as follows:\n\n");
            for(String s:rawdata)
                putText(s+"\n");
            putText("\n\n----End of data----\n");
            dataLoaded=true;
            loadFinished=true;
        } catch(Exception e) {
            putText("***Incorrect data found***");
            loadFinished=true;
            dataLoaded=false;
        }
    }
    
    void putText(final String text) {
        SwingUtilities.invokeLater( new Runnable() {
            public void run() {
                jta.append(text);
                jta.setCaretPosition(text.length());
            }
        } );
    }
    
    private void doLoad() {
        Thread t = new Thread(this);
        t.start();
    }
    
    /*
        List of attributes
     */
    ArrayList<String> rawdata = new ArrayList<String>();
    
    private JTabbedPane jt;
    private JTextArea jta;
    private JScrollPane jsc;
    private float[] data;
    private String[] legend;
    private boolean loadFinished,dataLoaded;
}
