/*
 * StringTableView.java
 *
 * Created on 19 de marzo de 2007, 15:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package readerandplotter;


import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

/**
 * This is a component for viewing and editing columnar information.
 * @author bruegel
 */
public class StringTableView extends javax.swing.JPanel implements TableModelListener {
    
    /**
     * Creates a default empty model.
     */
    public StringTableView() {
        initComponents();
    }
    
    /**
     * Creates a component with an empty model, to be stored in the container received
     * as an argument by this constructor.
     * @param mf The owner container
     */
    public StringTableView(MainFrame mf) {
        initComponents();
        this.mf = mf;
        this.jTable1.setModel(stm);
        this.jTable1.createDefaultColumnsFromModel();
        this.stm.addTableModelListener(this);
    }
    
    /**
     * Prepares a model and a table in which it will be displayed
     */
    public void initComponents(){
        
        this.stm = new StringTableModel();
        
        this.jTable1 = new JTable(stm);
        
        this.jTable1.setPreferredScrollableViewportSize(new Dimension(400,400));
        
        
        this.jTable1.setShowGrid(true);
        //Do not adjust column widths automatically; use a scrollbar.
        this.jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        
        jsc = new JScrollPane(jTable1);
        
        jsc.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        jsc.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        this.add(jsc,BorderLayout.CENTER);
        
    }
    
    
    
    private javax.swing.JTable jTable1;
    private MainFrame mf;
    private StringTableModel stm;
    private JScrollPane jsc;
    /**
     * Getter for the table
     * @return The table
     */
    public javax.swing.JTable getJTable1() {
        return jTable1;
    }
    
    /**
     * Setter for the table
     * @param jTable1 The table component to be used for viewing the model.
     */
    public void setJTable1(javax.swing.JTable jTable1) {
        this.jTable1 = jTable1;
    }
    
    /**
     * Getter for the model
     */
    public StringTableModel getStm() {
        return stm;
    }
    
    /**
     * Setter for the model
     * @param stm The model to be displayed in this component.
     */
    public void setStm(StringTableModel stm) {
        this.stm = stm;
    }
    
    /**
     * Getter for the scroll pane
     */
    public JScrollPane getJsc() {
        return jsc;
    }
    
    /**
     * Setter for the scroll pane
     */
    public void setJsc(JScrollPane jsc) {
        this.jsc = jsc;
    }
    
    public void tableChanged(TableModelEvent tableModelEvent) {
        mf.setDataChanged(true);
        //System.out.println("In case you did not know, data have changed.");
        int numberOfRows = stm.getRowCount();
        int numberOfCols = 2;
        float[][] data = new float[numberOfRows][2];
        for(int row=0;row < numberOfRows;row++)
            for(int col=0;col<numberOfCols;col++)
                data[row][col]= Float.parseFloat((String)stm.getValueAt(row,col));
        mf.setData(data);
        
    }
}
